/*
 * ʰץץեѥɥ饤
 * db.c: ץեǡδ
 *
 * (C)Copyright 2009, Yashiro Takeshi <yashiromann@nifty.com>
 */

#define	DEBUG_MODULE "(vf)"
#include <tk/tkernel.h>
#include <tk/util.h>
#include <assert.h>
#include <string.h>
#include "vf.h"

#define vf_malloc Vmalloc
#define vf_free Vfree

/* vf_leaf_nbits + vf_node_nbits * (vf_tree_depth - 1) == 32  */
#define vf_leaf_nbits 4
#define vf_leaf_nelems (2 << vf_leaf_nbits)
#define vf_leaf_mask (vf_leaf_nelems - 1)
#define vf_tree_depth  5
#define vf_node_nbits 7
#define vf_node_nelems (2 << vf_node_nbits)
#define vf_node_mask (vf_node_nelems - 1)


/* ץ󥰥ǡ(üΡ) */
typedef struct VFLeaf_ {
    VFTimes a[vf_leaf_nelems];
} VFLeaf;

/* ץ󥰥ǡ(֥Ρ) */
typedef struct VFNode_ {
    void* a[vf_node_nelems];
} VFNode;

#define cast_node(p) ((VFNode*)(p))
#define cast_leaf(p) ((VFLeaf*)(p))


VFTimes vf_total; /*  */
VFNode* vf_data = NULL; /* ѤΥΡ */


VFTimes* vf_get_entry(void* pc, BOOL generate)
{
    UW upc = (UW)pc;
    void** p;
    int i, nbits, idx;

    p = (void**)(&vf_data);
    nbits = 32;

    for (i = 0; i < vf_tree_depth - 1; i++) {
        if (*p == NULL) {
            if (!generate) {
                return NULL;
            }
            *p = (VFNode*)vf_malloc(sizeof(VFNode));
            memset(*p, 0, sizeof(VFNode));
        }
        idx = (upc >> (nbits - vf_node_nbits)) & vf_node_mask;
        p = &(cast_node(*p)->a[idx]);
        nbits -= vf_node_nbits;
    }

    if (*p == NULL) {
        if (!generate) {
            return NULL;
        }
        *p = (VFLeaf*)vf_malloc(sizeof(VFLeaf));
        memset(*p, 0, sizeof(VFLeaf));
    }

    assert(nbits == vf_leaf_nbits);
    return &(cast_leaf(*p)->a[upc & vf_leaf_mask]);
}


/* ƵƤӽФΤǡå¿˻ȤΤ */
static int vf_get_next_sub(VFEntry* entry, int n, void** ppc, 
                           void* e, int depth, BOOL eq)
{
    UW upc = (UW)(*ppc);
    int i, nbits, ret;
    int cnt = 0;
    BOOL nexteq;

    if (depth < vf_tree_depth - 1) {
        nbits = 32 - (depth + 1) * vf_node_nbits;
        for (i = (eq ? ((upc >> nbits) & vf_node_mask) : 0); 
             i < vf_node_nelems; i++) {
            upc &= ~(vf_node_mask << nbits);
            upc |= (i << nbits);
            if (cast_node(e)->a[i] != NULL) {
                ret = vf_get_next_sub(entry + cnt, n - cnt, (void**)&upc,
                                      cast_node(e)->a[i], depth + 1, eq);
                if (ret > 0) {
                    *ppc = (void*)upc;
                    cnt += ret;
                    if (cnt >= n) {
                        return cnt;
                    }
                }
            }
            eq = FALSE;
        }
    }
    else {
        for (i = (eq ? ((upc & vf_leaf_mask) + 1) : 0); 
             i < vf_leaf_nelems; i++) {
            if (cast_leaf(e)->a[i].self_rtime != 0) {
                entry[cnt].t = cast_leaf(e)->a[i];
                upc = (upc & ~vf_leaf_mask) | i;
                entry[cnt].pc = (W)upc;
                *ppc = (void*)upc;
                cnt++;
                if (cnt >= n) {
                    return cnt;
                }
            }
        }
    }
    return cnt;
}


/*
 * PCͤ PC > *ppc ȥ򡢾˺ n ɤ߽Ф
 * ppc ͤɤ߽ФǸPCͤ˽񤭴롣
 * (: ºݤɤ߽ФĿ)
 *
 * *ppc = 0 Ƥ顢0 ֤äƤޤ vf_get_next 򷫤֤С
 * ǡɤ߽ФȤǤ롣
 */
int vf_get_next(VFEntry* entry, int n, void** ppc)
{
    if (vf_data == NULL) {
        return 0;
    }
    return vf_get_next_sub(entry, n, ppc, vf_data, 0, TRUE);
}


/* ƵƤӽФΤǡå¿˻ȤΤ */
static void vf_clear_sub(void* e, int depth)
{
    if (depth < vf_tree_depth - 1) {
        int i;
        for (i = 0; i < vf_node_nelems; i++) {
            if (cast_node(e)->a[i] != NULL) {
                vf_clear_sub(cast_node(e)->a[i], depth + 1);
                cast_node(e)->a[i] = NULL;
            }
        }
    }
    vf_free(e);
}


void vf_clear()
{
    if (vf_data != NULL) {
        /* ƵƤӽФǥĥ꡼Τ */
        vf_clear_sub(vf_data, 0);
    }

    vf_data = NULL;
    memset(&vf_total, 0, sizeof(VFTimes));
}

